Status: Closed

Priority: Normal

Assignee:

Category: Data Provider

Affected QGIS version:master Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied: Resolution: fixed/implemented
Crashes QGIS or corrupls data: Copied to github as #: 14629
Description

To reproduce this issue, try the following:

In editing mode, use field calculator to add a new Integer field with width = 1 and fill it with the value 100.
This is obviously not going to work because we would need at least a width of 3 to accommodate this value.
Instead, '100' is happily displayed in the attribute table.

Only when | deactivate editing mode, the value suddenly gets truncated and reads '1' now.

In this simple case it's easy to spot. In other cases this can severely throw users off their path.
There should be some kind of warning.

Related issues:
Duplicated by QGIS Application - Bug report # 4955: Wrong results, when calcu... Closed 2012-02-07

History

#1 - 2012-02-04 10:07 AM - Maxim Dubinin

+1

This is very confusing especially for new users. Here is another test case:
1. Create a real field with 12 digits without decimals

2. Try to enter a value of lets say 1234567890123

3. Seemingly values enters ok.

4. After saving it changes to overflow -2147483648

Whatever the logic behind it, it should better warn the user not letting him enter such value instead of giving cryptic answer.

#2 - 2012-02-08 10:38 AM - Alexander Bruy

See also #4955

#3 - 2012-09-04 11:54 AM - Paolo Cavallini

- Target version changed from Version 1.8.0 to Version 2.0.0

#4 - 2014-06-28 07:41 AM - Jiirgen Fischer
- Target version changed from Version 2.0.0 to Future Release - Lower Priority

#5 - 2015-10-10 01:22 AM - Anita Graser
When trying to reproduce this, | now found that the values are not truncated anymore.

That means: | can store values like 100 in an integer field with length 1 ...

#6 - 2017-05-01 01:10 AM - Giovanni Manghi
- Regression? set to No
- Easy fix? set to No

#7 - 2019-03-09 04:04 PM - Giovanni Manghi
- Status changed from Open to Closed
- Resolution set to end of life

End of life notice: QGIS 2.18 LTR
Source:
http://blog.qgis.org/2019/03/09/end-of-life-notice-qgis-2-18-ltr/

#8 - 2019-03-09 04:53 PM - Anita Graser
- Description updated

I've tested this using Shapefiles in 3.7: for integer fields, the length doesn't seem to matter. There is no warning but the values also aren't truncated. For
decimal numbers, the attribute table now prevents inserting invalid values.

#9 - 2019-03-09 05:01 PM - Anita Graser
- Resolution changed from end of life to fixed/implemented
